{
===============================================================================
  Copyright (©) 2006. Rodax Software.
===============================================================================
  Los contenidos de este fichero son propiedad de Rodax Software titular del
  copyright. Este fichero sólo podrá ser copiado, distribuido y utilizado,
  en su totalidad o en parte, con el permiso escrito de Rodax Software, o de
  acuerdo con los términos y condiciones establecidas en el acuerdo/contrato
  bajo el que se suministra.
  -----------------------------------------------------------------------------
  Web:  www.rodax-software.com
===============================================================================
  Fecha primera versión: 22-05-2006
  Versión actual: 1.0.0
  Fecha versión actual: 22-05-2006
===============================================================================
  Modificaciones:

    Fecha         Comentarios
    ---------------------------------------------------------------------------
===============================================================================
}

unit uEditorUnidadesMedida;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, DB, StdCtrls, DBCtrls, uDADataTable, ActnList,
  uIEditorUnidadesMedida, uCustomEditor, uGUIBase, ExtCtrls,
  ComCtrls, uBizUnidadesMedida, uUnidadesMedidaController, uDAInterfaces;

type
  TfEditorUnidadesMedida = class(TCustomEditor, IEditorUnidadesMedida)
    ActionList1: TActionList;
    DADataSource: TDADataSource;
    ListaUnidadesMedida: TDBLookupListBox;
    actAnadir: TAction;
    actEliminar: TAction;
    bEliminar: TButton;
    actAceptar: TAction;
    actCancelar: TAction;
    bAceptar: TButton;
    bCancelar: TButton;
    actCerrar: TAction;
    PageControl1: TPageControl;
    TabSheet1: TTabSheet;
    Label1: TLabel;
    Label2: TLabel;
    Bevel1: TBevel;
    eCategoria: TLabel;
    editUnidadMedida: TEdit;
    bAnadir: TButton;
    procedure FormShow(Sender: TObject);
    procedure CustomEditorClose(Sender: TObject; var Action: TCloseAction);

    procedure actAnadirExecute(Sender: TObject);
    procedure actEliminarExecute(Sender: TObject);
    procedure actAceptarExecute(Sender: TObject);
    procedure actCancelarExecute(Sender: TObject);
    procedure actCerrarExecute(Sender: TObject);
    procedure actAnadirUpdate(Sender: TObject);
    procedure actEliminarUpdate(Sender: TObject);
  protected
    FUnidadesMedida: IBizUnidadMedida;
    FController: IUnidadesMedidaController;
    function GetUnidadesMedida: IBizUnidadMedida;
    procedure SetUnidadesMedida(const Value: IBizUnidadMedida);
    function GetController : IUnidadesMedidaController;
    procedure SetController (const Value : IUnidadesMedidaController);
  public
    property UnidadesMedida: IBizUnidadMedida read GetUnidadesMedida write SetUnidadesMedida;
    property Controller : IUnidadesMedidaController read GetController write SetController;
  end;


implementation
{$R *.dfm}

{ TfEditorUnidadesMedida }

uses
  uDialogUtils;

function TfEditorUnidadesMedida.GetController: IUnidadesMedidaController;
begin
  Result := FController;
end;

function TfEditorUnidadesMedida.GetUnidadesMedida: IBizUnidadMedida;
begin
  Result := FUnidadesMedida;
end;

procedure TfEditorUnidadesMedida.SetController(const Value: IUnidadesMedidaController);
begin
  FController := Value;
end;

procedure TfEditorUnidadesMedida.SetUnidadesMedida(const Value: IBizUnidadMedida);
begin
  FUnidadesMedida := Value;
  DADataSource.DataTable := (FUnidadesMedida as IBizUnidadMedida).DataTable;
  DADataSource.DataTable.Open;
end;

procedure TfEditorUnidadesMedida.actAnadirExecute(Sender: TObject);
begin
  if not FController.Localizar(UnidadesMedida, editUnidadMedida.Text) then
  begin
    UnidadesMedida.Append;
    UnidadesMedida.DESCRIPCION := editUnidadMedida.Text;
    UnidadesMedida.Post;
    editUnidadMedida.Clear;
    ListaUnidadesMedida.SetFocus;
  end
  else
    ShowErrorMessage('Ya existe la unidad ' + editUnidadMedida.Text,
      'Ya existe la unidad ''' + editUnidadMedida.Text + ''' en la lista.');
end;

procedure TfEditorUnidadesMedida.actEliminarExecute(Sender: TObject);
begin
  UnidadesMedida.Delete;
  ListaUnidadesMedida.SetFocus;
end;

procedure TfEditorUnidadesMedida.actEliminarUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := (FUnidadesMedida.DataTable.RecordCount > 0) and
                                  (Length(ListaUnidadesMedida.SelectedItem) > 0);

end;

procedure TfEditorUnidadesMedida.CustomEditorClose(Sender: TObject; var Action: TCloseAction);
begin
  FUnidadesMedida := Nil;
  FController := Nil;
end;

procedure TfEditorUnidadesMedida.actAceptarExecute(Sender: TObject);
begin
  try
    UnidadesMedida.DataTable.ApplyUpdates;
  except
    on E : Exception do begin
      UnidadesMedida.DataTable.CancelUpdates;
      ShowErrorMessage('Error al guardar cambios', 'Se ha producido un error grave', E);
      exit;
    end;
  end;
  actCerrar.Execute;
end;

procedure TfEditorUnidadesMedida.actCancelarExecute(Sender: TObject);
begin
  UnidadesMedida.DataTable.CancelUpdates;
  actCerrar.Execute;
end;

procedure TfEditorUnidadesMedida.actCerrarExecute(Sender: TObject);
begin
  Close;
end;

procedure TfEditorUnidadesMedida.actAnadirUpdate(Sender: TObject);
begin
  (Sender as TAction).Enabled := (Length(editUnidadMedida.Text) > 0)
end;

procedure TfEditorUnidadesMedida.FormShow(Sender: TObject);
begin
  if not FUnidadesMedida.DataTable.Active then
     FUnidadesMedida.DataTable.Active := true;

  FUnidadesMedida.DataTable.Sort(['DESCRIPCION'], [sdAscending]);
  EditUnidadMedida.SetFocus;
end;

end.
